/*
 *	main.c
 *
 *	M62vC[
 *
 *	* Sat Feb 07 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* XvCg`BKvɉăCN[hĂBsprite.h̕ҏWKvłB */
//#include "sprite.h"
//#define DEFINE_SPRITE
//#include "sprite.h"
//#undef  DEFINE_SPRITE

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

//extern const unsigned char PAT[];
//extern const unsigned char BG[];
//TEXTURE pat;
//TEXTURE bg;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void run();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	//turbo(1); /* S48MHz[h */
	turbo(7); /* 48MHz/1WAIT */
	srand(pceTimerGetCount());
	/* rbg}bvB */
	//texture_init(&pat, PAT);
	//texture_init(&bg, BG);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		//if(joy & TRG_START) {
		if(0) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	
 ****************************************************************************/

DRIVER g_driver;

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _TRACK {
	const char* name;				/* gbN */
	int reqno;					/* NGXgio[ */
} TRACK;

typedef struct _ROMSET {
	int year;					/* N */
	const char* name;				/* Q[ */
	const char* file;				/* ROMZbgt@C (NULL:Ή) */
	const ROM* roms;				/* ROMXg */
	int num_roms;					/* ROM */
	const TRACK* tracks;				/* gbNXg */
	int num_tracks;					/* gbN */
	void (*init)(DRIVER* driver);			/* [` */
	void (*play)(DRIVER* driver, int reqno);	/* t[` */
	void (*mix)(DRIVER* driver, short wbuff[]);	/* ~LVOR[obN */
} ROMSET;

/****************************************************************************
 *	Xp^X
 ****************************************************************************/

const ROMSET spartanx_romset = {
	1984,
	"Xp^X",
};

/****************************************************************************
 *	[hi[
 ****************************************************************************/

void ldrun_init(DRIVER* driver);
void ldrun_play(DRIVER* driver, int reqno);
void ldrun_mix(DRIVER* driver, short wbuff[]);

const ROM ldrun_roms[] = {
	{ "lr-a-3f", 0xc000, 0x2000, 0x7a96accd },
	{ "lr-a-3h", 0xe000, 0x2000, 0x3f7f3939 },
};
const TRACK ldrun_tracks[] = {
	{ "TRACK 32", 32 },
	{ "TRACK 33", 33 },
	{ "TRACK 34", 34 },
	{ "TRACK 35", 35 },
	{ "TRACK 36", 36 },
	{ "TRACK 37", 37 },
	{ "TRACK 38", 38 },
	{ "TRACK 39", 39 },
};
const ROMSET ldrun_romset = {
	1984,
	"[hi[",
	"ldrun.zip",
	ldrun_roms,
	sizeof ldrun_roms / sizeof(ROM),
	ldrun_tracks,
	sizeof ldrun_tracks / sizeof(TRACK),
	ldrun_init,
	ldrun_play,
	ldrun_mix,
};

void
ldrun_init(DRIVER* driver)
{
	unsigned char* mem = driver->mem;

	/* pb`āB */
	//FB43 : 96 C0 ldaa X00C0 /* 125[Hz]JE^ */
	//FB45 : 27 3E beq  LFB85 /* 0Ȃ珈Ȃ */
	//
	mem[0xfb43] = 0x3e;	/* WAI */
	mem[0xfb44] = 0x01;	/* NOP */
	mem[0xfb45] = 0x01;	/* NOP */
	mem[0xfb46] = 0x01;	/* NOP */

	/* MainCPŨNGXgB */
	mem[2] = 0xff;
}

#define GC4K1	0xbd	/* 4KHzO[oJE^1 */
#define GC4K2	0xbf	/* 4KHzO[oJE^2 */
#define GC125	0xc0	/* 125HzO[oJE^ */

void
ldrun_play(DRIVER* driver, int reqno)
{
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;

	/* 125[Hz]JE^0WAITȂ悤AÔ߁B */
	mem[GC125] = 1;

	/* M6803Port1-INɃNGXgio[IRQsB */
	mem[2] = reqno;
	m6800_irq(m6803);
}

void
ldrun_mix(DRIVER* driver, short wbuff[])
{
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;
	int i;

	/* M62TEh{[hMSM52054KHz荞݂ŋ쓮܂B
	 * 1/50b80B
	 * 1/50b̃Tv320(=AY38910BUFLEN)Ȃ̂ŁA1񓖂320/80=4Tv~LVO܂B
	 * RA肭؂܂...(^^)
	 */
	for(i = 0; i < 4000 / 50; i++) {
		m6800_run(m6803, CLOCK / 4000);
		/*{{{͂̏NMI[`Ă̂łA܂ƂɃG~[gƊԂɍ܂*/
		mem[GC4K1]++; /* 4KHzO[oJE^ */
		mem[GC4K2]++; /* 4KHzO[oJE^ */
		if(!(mem[GC4K2] & 0xf)) {
			mem[GC125]++; /* 125HzO[oJE^ */
			if(mem[GC125]) m6803->wait = 0; /* pb`ĂƂWAITĂ܂ */
		}
		/*}}{͂̏NMI[`Ă̂łA܂ƂɃG~[gƊԂɍ܂*/
		ay38910_mix12(driver, wbuff, 320 / 80);
		wbuff += 320 / 80;
	}
}

#undef GC4K1
#undef GC4K2
#undef GC125

/****************************************************************************
 *	[hi[II
 ****************************************************************************/

void ldrun2_init(DRIVER* driver);
void ldrun2_play(DRIVER* driver, int reqno);
void ldrun2_mix(DRIVER* driver, short wbuff[]);

const ROM ldrun2_roms[] = {
	{ "lr2-a-3e", 0xa000, 0x2000, 0x853f3898 },
	{ "lr2-a-3f", 0xc000, 0x2000, 0x7a96accd },
	{ "lr2-a-3h", 0xe000, 0x2000, 0x2a0e83ca },
};
const TRACK ldrun2_tracks[] = {
	{ "TRACK 32", 32 },
	{ "TRACK 33", 33 },
	{ "TRACK 34", 34 },
	{ "TRACK 35", 35 },
	{ "TRACK 36", 36 },
	{ "TRACK 37", 37 },
	{ "TRACK 38", 38 },
	{ "TRACK 39", 39 },
};
const ROMSET ldrun2_romset = {
	1984,
	"[hi[II",
	"ldrun2.zip",
	ldrun2_roms,
	sizeof ldrun2_roms / sizeof(ROM),
	ldrun2_tracks,
	sizeof ldrun2_tracks / sizeof(TRACK),
	ldrun2_init,
	ldrun2_play,
	ldrun2_mix,
};

void
ldrun2_init(DRIVER* driver)
{
	/* [hi[ƓłB */
	ldrun_init(driver);
}

void
ldrun2_play(DRIVER* driver, int reqno)
{
	/* [hi[ƓłB */
	ldrun_play(driver, reqno);
}

void
ldrun2_mix(DRIVER* driver, short wbuff[])
{
	/* [hi[ƓłB */
	ldrun_mix(driver, wbuff);
}

/****************************************************************************
 *	[hi[III
 ****************************************************************************/

void ldrun3_init(DRIVER* driver);
void ldrun3_play(DRIVER* driver, int reqno);
void ldrun3_mix(DRIVER* driver, short wbuff[]);

const ROM ldrun3_roms[] = {
	{ "lr3-a-3d", 0x8000, 0x4000, 0x28be68cd },
	{ "lr3-a-3f", 0xc000, 0x4000, 0xcb7186b7 },
};
const TRACK ldrun3_tracks[] = {
	{ "TRACK 32", 32 },
	{ "TRACK 33", 33 },
	{ "TRACK 34", 34 },
	{ "TRACK 35", 35 },
	{ "TRACK 37", 37 },
	{ "TRACK 38", 38 },
	{ "TRACK 40", 40 },
	{ "TRACK 41", 41 },
	{ "TRACK 42", 42 },
};
const ROMSET ldrun3_romset = {
	1985,
	"[hi[III",
	"ldrun3.zip",
	ldrun3_roms,
	sizeof ldrun3_roms / sizeof(ROM),
	ldrun3_tracks,
	sizeof ldrun3_tracks / sizeof(TRACK),
	ldrun3_init,
	ldrun3_play,
	ldrun3_mix,
};

void
ldrun3_init(DRIVER* driver)
{
	unsigned char* mem = driver->mem;

	/* pb`āB */
	//FB61 : 96 CA ldaa X00CA /* 125[Hz]JE^ */
	//FB63 : 27 4E beq  LFBB3 /* 0Ȃ珈Ȃ */
	//
	mem[0xfb61] = 0x3e;	/* WAI */
	mem[0xfb62] = 0x01;	/* NOP */
	mem[0xfb63] = 0x01;	/* NOP */
	mem[0xfb64] = 0x01;	/* NOP */

	/* MainCPŨNGXgB */
	mem[2] = 0xff;
}

#define GC4K1	0xc7	/* 4KHzO[oJE^1 */
#define GC4K2	0xc9	/* 4KHzO[oJE^2 */
#define GC125	0xca	/* 125HzO[oJE^ */

void
ldrun3_play(DRIVER* driver, int reqno)
{
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;

	/* 125[Hz]JE^0WAITȂ悤AÔ߁B */
	mem[GC125] = 1;

	/* M6803Port1-INɃNGXgio[IRQsB */
	mem[2] = reqno;
	m6800_irq(m6803);
}

void
ldrun3_mix(DRIVER* driver, short wbuff[])
{
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;
	int i;

	/* M62TEh{[hMSM52054KHz荞݂ŋ쓮܂B
	 * 1/50b80B
	 * 1/50b̃Tv320(=AY38910BUFLEN)Ȃ̂ŁA1񓖂320/80=4Tv~LVO܂B
	 * RA肭؂܂...(^^)
	 */
	for(i = 0; i < 4000 / 50; i++) {
		m6800_run(m6803, CLOCK / 4000);
		/*{{{͂̏NMI[`Ă̂łA܂ƂɃG~[gƊԂɍ܂*/
		mem[GC4K1]++; /* 4KHzO[oJE^ */
		mem[GC4K2]++; /* 4KHzO[oJE^ */
		if(!(mem[GC4K2] & 0xf)) {
			mem[GC125]++; /* 125HzO[oJE^ */
			if(mem[GC125]) m6803->wait = 0; /* pb`ĂƂWAITĂ܂ */
		}
		/*}}{͂̏NMI[`Ă̂łA܂ƂɃG~[gƊԂɍ܂*/
		ay38910_mix12(driver, wbuff, 320 / 80);
		wbuff += 320 / 80;
	}
}

#undef GC4K1
#undef GC4K2
#undef GC125

/****************************************************************************
 *	bgbg
 ****************************************************************************/

void lotlot_init(DRIVER* driver);
void lotlot_play(DRIVER* driver, int reqno);
void lotlot_mix(DRIVER* driver, short wbuff[]);

const ROM lotlot_roms[] = {
	{ "lot-a-3h", 0xe000, 0x2000, 0x0781cee7 },
};
const TRACK lotlot_tracks[] = {
	{ "TRACK 37", 37 },
	{ "TRACK 38", 38 },
	{ "TRACK 39", 39 },
	{ "TRACK 40", 40 },
	{ "TRACK 41", 41 },
	{ "TRACK 42", 42 },
	{ "TRACK 43", 43 },
};
const ROMSET lotlot_romset = {
	1985,
	"bgbg",
	"lotlot.zip",
	lotlot_roms,
	sizeof lotlot_roms / sizeof(ROM),
	lotlot_tracks,
	sizeof lotlot_tracks / sizeof(TRACK),
	lotlot_init,
	lotlot_play,
	lotlot_mix,
};

void
lotlot_init(DRIVER* driver)
{
	unsigned char* mem = driver->mem;

	/* pb`āB */
	//FB73 : 96 CA ldaa X00CA /* 125[Hz]JE^ */
	//FB75 : 27 4F beq  LFBC6 /* 0Ȃ珈Ȃ */
	//
	mem[0xfb73] = 0x3e;	/* WAI */
	mem[0xfb74] = 0x01;	/* NOP */
	mem[0xfb75] = 0x01;	/* NOP */
	mem[0xfb76] = 0x01;	/* NOP */

	/* MainCPŨNGXgB */
	mem[2] = 0xff;
}

void
lotlot_play(DRIVER* driver, int reqno)
{
	/* [hi[IIIƓB */
	ldrun3_play(driver, reqno);
}

void
lotlot_mix(DRIVER* driver, short wbuff[])
{
	/* [hi[IIIƓB */
	ldrun3_mix(driver, wbuff);
}

/****************************************************************************
 *	XyJ[
 ****************************************************************************/

const ROMSET spelunkr_romset = {
	1985,
	"XyJ[",
};

/****************************************************************************
 *	[hi[IV
 ****************************************************************************/

void ldrun4_init(DRIVER* driver);
void ldrun4_play(DRIVER* driver, int reqno);
void ldrun4_mix(DRIVER* driver, short wbuff[]);

const ROM ldrun4_roms[] = {
	{ "lr4-a-3d", 0x8000, 0x4000, 0x86c6d445 },
	{ "lr4-a-3f", 0xc000, 0x4000, 0x097c6c0a },
};
const TRACK ldrun4_tracks[] = {
	{ "TRACK 32", 32 },
	{ "TRACK 33", 33 },
	{ "TRACK 34", 34 },
	{ "TRACK 35", 35 },
	{ "TRACK 37", 37 },
	{ "TRACK 38", 38 },
	{ "TRACK 39", 39 },
	{ "TRACK 40", 40 },
	{ "TRACK 41", 41 },
	{ "TRACK 42", 42 },
};
const ROMSET ldrun4_romset = {
	1985,
	"[hi[IV",
	"ldrun4.zip",
	ldrun4_roms,
	sizeof ldrun4_roms / sizeof(ROM),
	ldrun4_tracks,
	sizeof ldrun4_tracks / sizeof(TRACK),
	ldrun4_init,
	ldrun4_play,
	ldrun4_mix,
};

void
ldrun4_init(DRIVER* driver)
{
	unsigned char* mem = driver->mem;

	/* pb`āB */
	//FB59 : 96 D0 ldaa X00D0 /* 125[Hz]JE^ */
	//FB5b : 27 4E beq  LFBAB /* 0Ȃ珈Ȃ */
	//
	mem[0xfb59] = 0x3e;	/* WAI */
	mem[0xfb5a] = 0x01;	/* NOP */
	mem[0xfb5b] = 0x01;	/* NOP */
	mem[0xfb5c] = 0x01;	/* NOP */

	/* MainCPŨNGXgB */
	mem[2] = 0xff;
}

#define GC4K1	0xcd	/* 4KHzO[oJE^1 */
#define GC4K2	0xcf	/* 4KHzO[oJE^2 */
#define GC125	0xd0	/* 125HzO[oJE^ */

void
ldrun4_play(DRIVER* driver, int reqno)
{
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;

	/* 125[Hz]JE^0WAITȂ悤AÔ߁B */
	mem[GC125] = 1;

	/* M6803Port1-INɃNGXgio[IRQsB */
	mem[2] = reqno;
	m6800_irq(m6803);
}

void
ldrun4_mix(DRIVER* driver, short wbuff[])
{
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;
	int i;

	/* M62TEh{[hMSM52054KHz荞݂ŋ쓮܂B
	 * 1/50b80B
	 * 1/50b̃Tv320(=AY38910BUFLEN)Ȃ̂ŁA1񓖂320/80=4Tv~LVO܂B
	 * RA肭؂܂...(^^)
	 */
	for(i = 0; i < 4000 / 50; i++) {
		m6800_run(m6803, CLOCK / 4000);
		/*{{{͂̏NMI[`Ă̂łA܂ƂɃG~[gƊԂɍ܂*/
		mem[GC4K1]++; /* 4KHzO[oJE^ */
		mem[GC4K2]++; /* 4KHzO[oJE^ */
		if(!(mem[GC4K2] & 0xf)) {
			mem[GC125]++; /* 125HzO[oJE^ */
			if(mem[GC125]) m6803->wait = 0; /* pb`ĂƂWAITĂ܂ */
		}
		/*}}{͂̏NMI[`Ă̂łA܂ƂɃG~[gƊԂɍ܂*/
		ay38910_mix12(driver, wbuff, 320 / 80);
		wbuff += 320 / 80;
	}
}

#undef GC4K1
#undef GC4K2
#undef GC125

/****************************************************************************
 *	`
 ****************************************************************************/

void kidniki_init(DRIVER* driver);
void kidniki_play(DRIVER* driver, int reqno);
void kidniki_mix(DRIVER* driver, short wbuff[]);

const ROM kidniki_roms[] = {
	{ "dr00.3a",  0x4000, 0x04000, 0x458309f7 },
	{ "dr01.3cd", 0x8000, 0x04000, 0xe66897bd },
	{ "dr02.3f",  0xc000, 0x04000, 0xf9e31e26 },
};
const TRACK kidniki_tracks[] = {
	{ "TRACK 16", 16 },
	{ "TRACK 17", 17 },
	{ "TRACK 18", 18 },
	{ "TRACK 19", 19 },
	{ "TRACK 20", 20 },
	{ "TRACK 21", 21 },
	{ "TRACK 22", 22 },
	{ "TRACK 23", 23 },
	//{ "TRACK 24", 24 },	邯ǃnOAbv܂...
	{ "TRACK 25", 25 },
	{ "TRACK 26", 26 },
};
const ROMSET kidniki_romset = {
	1986,
	"`",
	"kidniki.zip",
	kidniki_roms,
	sizeof kidniki_roms / sizeof(ROM),
	kidniki_tracks,
	sizeof kidniki_tracks / sizeof(TRACK),
	kidniki_init,
	kidniki_play,
	kidniki_mix,
};

void
kidniki_init(DRIVER* driver)
{
	unsigned char* mem = driver->mem;

	/* pb`āB */
	//FA87 : 96 CB ldaa X00CB /* 125[Hz]JE^ */
	//FA89 : 27 44 beq  LFACF /* 0Ȃ珈Ȃ */
	//
	mem[0xfa87] = 0x3e;	/* WAI */
	mem[0xfa88] = 0x01;	/* NOP */
	mem[0xfa89] = 0x01;	/* NOP */
	mem[0xfa8a] = 0x01;	/* NOP */

	/* MainCPŨNGXgB */
	mem[2] = 0xff;
}

#define GC4K1	0xc8	/* 4KHzO[oJE^1 */
#define GC4K2	0xca	/* 4KHzO[oJE^2 */
#define GC125	0xcb	/* 125HzO[oJE^ */

void
kidniki_play(DRIVER* driver, int reqno)
{
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;

	/* 125[Hz]JE^0WAITȂ悤AÔ߁B */
	mem[GC125] = 1;

	/* M6803Port1-INɃNGXgio[IRQsB */
	mem[2] = reqno;
	m6800_irq(m6803);
}

void
kidniki_mix(DRIVER* driver, short wbuff[])
{
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;
	int i;

	/* M62TEh{[hMSM52054KHz荞݂ŋ쓮܂B
	 * 1/50b80B
	 * 1/50b̃Tv320(=AY38910BUFLEN)Ȃ̂ŁA1񓖂320/80=4Tv~LVO܂B
	 * RA肭؂܂...(^^)
	 */
	for(i = 0; i < 4000 / 50; i++) {
		m6800_run(m6803, CLOCK / 4000);
		/*{{{͂̏NMI[`Ă̂łA܂ƂɃG~[gƊԂɍ܂*/
		mem[GC4K1]++; /* 4KHzO[oJE^ */
		mem[GC4K2]++; /* 4KHzO[oJE^ */
		if(!(mem[GC4K2] & 0xf)) {
			mem[GC125]++; /* 125HzO[oJE^ */
			if(mem[GC125]) m6803->wait = 0; /* pb`ĂƂWAITĂ܂ */
		}
		/*}}{͂̏NMI[`Ă̂łA܂ƂɃG~[gƊԂɍ܂*/
		ay38910_mix12(driver, wbuff, 320 / 80);
		wbuff += 320 / 80;
	}
}

#undef GC4K1
#undef GC4K2
#undef GC125

/****************************************************************************
 *	db`
 ****************************************************************************/

void youjyudn_init(DRIVER* driver);
void youjyudn_play(DRIVER* driver, int reqno);
void youjyudn_mix(DRIVER* driver, short wbuff[]);

const ROM youjyudn_roms[] = {
	{ "yju_a3fb.bin", 0xc000, 0x04000, 0xe15c8030 },
};
const TRACK youjyudn_tracks[] = {
	{ "TRACK 16", 16 },
	{ "TRACK 17", 17 },
	{ "TRACK 18", 18 },
	{ "TRACK 19", 19 },
	{ "TRACK 20", 20 },
	{ "TRACK 21", 21 },
	{ "TRACK 23", 23 },
	{ "TRACK 24", 24 },
	{ "TRACK 25", 25 },
	{ "TRACK 26", 26 },
	{ "TRACK 27", 27 },
	{ "TRACK 28", 28 },
	{ "TRACK 29", 29 },
	{ "TRACK 31", 31 },
	{ "TRACK 33", 33 },
	{ "TRACK 34", 34 },
	{ "TRACK 36", 36 },
};
const ROMSET youjyudn_romset = {
	1986,
	"db`",
	"youjyudn.zip",
	youjyudn_roms,
	sizeof youjyudn_roms / sizeof(ROM),
	youjyudn_tracks,
	sizeof youjyudn_tracks / sizeof(TRACK),
	youjyudn_init,
	youjyudn_play,
	youjyudn_mix,
};

void
youjyudn_init(DRIVER* driver)
{
	unsigned char* mem = driver->mem;

	/* pb`āB */
	//FB6d : 96 CA ldaa X00CA /* 125[Hz]JE^ */
	//FB6f : 27 4F beq  LFBC0 /* 0Ȃ珈Ȃ */
	//
	mem[0xfb6d] = 0x3e;	/* WAI */
	mem[0xfb6e] = 0x01;	/* NOP */
	mem[0xfb6f] = 0x01;	/* NOP */
	mem[0xfb70] = 0x01;	/* NOP */

	/* MainCPŨNGXgB */
	mem[2] = 0xff;
}

void
youjyudn_play(DRIVER* driver, int reqno)
{
	/* [hi[IIIƓB */
	ldrun3_play(driver, reqno);
}

void
youjyudn_mix(DRIVER* driver, short wbuff[])
{
	/* [hi[IIIƓB */
	ldrun3_mix(driver, wbuff);
}

/****************************************************************************
 *	run
 ****************************************************************************/

const ROMSET* romset_list[] = {
	&spartanx_romset,	/* Ή */
	&ldrun_romset,
	&ldrun2_romset,
	&ldrun3_romset,
	&lotlot_romset,
	&spelunkr_romset,	/* Ή */
	&ldrun4_romset,
	&kidniki_romset,
	&youjyudn_romset,
};
#define ROMSET_COUNT	(sizeof romset_list / sizeof *romset_list)

/****************************************************************************
 *	run
 ****************************************************************************/

#define MAX_DISP	7

int file_sel(int i_file);
void track_sel(const ROMSET* romset);
int stream_callback(short wbuff[], int param);

void
run()
{
	DRIVER* driver = &g_driver;
	M6800* m6803 = &driver->m6803;
	unsigned char* mem = driver->mem;
	AY38910* ay1 = &driver->ay1;
	AY38910* ay2 = &driver->ay2;

	int retval;
	int i_file;
	const ROMSET* romset;

	i_file = 0;
	for(;;) {
		/* t@CIB */
		i_file = file_sel(i_file);
		romset = romset_list[i_file];

		/* ROMǂݍ݁B */
		memset(driver, 0, sizeof(DRIVER));
		retval = rom_load(romset->file, romset->roms, romset->num_roms, mem);
		if(retval != 0) {
			/*        012345678901234567890123 */
			err_disp("ROM̧ٓǍݎsł");
			continue;
		}

		/* ʂ̏B */
		romset->init(driver);

		/* ʂ̏B */
		m6800_reset(m6803, NULL, m6803_write);
		ay38910_reset(ay1, CLOCK, NULL, NULL);
		ay38910_reset(ay2, CLOCK, NULL, NULL);

		stream_play(AY38910BUFLEN, stream_callback, (int)romset->mix);

		/* gbNIB */
		track_sel(romset);

		stream_stop();
	}
}

int
file_sel(int cursel)
{
	int curtop = 0;
	int prevsel = -1; /* ͋` */
	int prevtop = -1; /* ͋` */

	int c, i, j, x, y, w;
	const ROMSET* romset;
	const char* s;

	for(;;) {
		schedule();

		/* I? */
		if(joy & TRG_SELECT) exit(0);

		/* t@CIύX? */
		if(joy & TRG_UP && cursel > 0               ) cursel--;
		if(joy & TRG_DN && cursel < ROMSET_COUNT - 1) cursel++;
		if(joy & TRG_LF) { cursel -= MAX_DISP; if(cursel < 0               ) cursel = 0;                }
		if(joy & TRG_RI) { cursel += MAX_DISP; if(cursel > ROMSET_COUNT - 1) cursel = ROMSET_COUNT - 1; }
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĕ`? */
		if(cursel != prevsel || curtop != prevtop) {
			prevsel = cursel;
			prevtop = curtop;
			surface_clear(&surface, 0);

			/* ROMZbgXg\B */
			y = 12;
			for(i = 0; i < MAX_DISP + 1; i++) {
				j = curtop + i;
				if(j > ROMSET_COUNT - 1) break;
				romset = romset_list[j];
				if(j == cursel) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 10 + 1, 2);
					c = 0;
				} else {
					c = 2;
				}
				if(!romset->file) c = 1; /* Ή */
				render_printf(&render, 4, y, 0x80, c, "%-20s%4d", romset->name, romset->year);
				y += 10;
			}

			/* ^Cg\B */
			s = "M62 Player";
			w = strlen(s) * 5;
			x = (DISP_X - w) / 2;
			render_rectangle_fill(&render, 0, 0, DISP_X, 11, 3);
			render_line(&render, 0        , 4, x - 4 , 4, 0);
			render_line(&render, x + w + 4, 4, DISP_X, 4, 0);
			render_line(&render, 0        , 6, x - 4 , 6, 0);
			render_line(&render, x + w + 4, 6, DISP_X, 6, 0);
			render_string(&render, x, 1, s, 0x80, 0);
		}

		/* Im? */
		if(joy & TRG_A) {
			romset = romset_list[cursel];
			if(romset->file) break; /* Ή */
		}
	}

	return cursel;
}

void
track_sel(const ROMSET* romset)
{
	int cursel = 0;
	int curtop = 0;
	int prevsel = -1; /* ͋` */
	int prevtop = -1; /* ͋` */
	int playing = -1;

	int c, i, j, x, y, w;
	const char* s;

	for(;;) {
		schedule();

		/* I? */
		if(joy & TRG_SELECT) exit(0);

		/* t@CIύX? */
		if(joy & TRG_UP && cursel > 0                     ) cursel--;
		if(joy & TRG_DN && cursel < romset->num_tracks - 1) cursel++;
		if(joy & TRG_LF) { cursel -= MAX_DISP; if(cursel < 0                     ) cursel = 0;                      }
		if(joy & TRG_RI) { cursel += MAX_DISP; if(cursel > romset->num_tracks - 1) cursel = romset->num_tracks - 1; }
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĕ`? */
		if(cursel != prevsel || curtop != prevtop) {
			prevsel = cursel;
			prevtop = curtop;
			surface_clear(&surface, 0);

			/* ROMZbgXg\B */
			y = 12;
			for(i = 0; i < MAX_DISP + 1; i++) {
				j = curtop + i;
				if(j > romset->num_tracks - 1) break;
				if(j == cursel) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 10 + 1, 2);
					c = 0;
				} else {
					c = 2;
				}
				if(j == playing) c++;
				render_printf(&render, 4, y, 0x80, c, "%s", romset->tracks[j].name);
				y += 10;
			}

			/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
			/* ^Cg\B */
			s = romset->name;
			w = strlen(s) * 5;
			x = (DISP_X - w) / 2;
			render_rectangle_fill(&render, 0, 0, DISP_X, 11, 3);
			render_line(&render, 0        , 4, x - 4 , 4, 0);
			render_line(&render, x + w + 4, 4, DISP_X, 4, 0);
			render_line(&render, 0        , 6, x - 4 , 6, 0);
			render_line(&render, x + w + 4, 6, DISP_X, 6, 0);
			render_string(&render, x, 1, s, 0x80, 0);
		}

		/* tJn? */
		if(joy & TRG_A) {
			romset->play(&g_driver, romset->tracks[cursel].reqno);
			playing = cursel;
			prevsel = -1; /* ĕ` */
			prevtop = -1; /* ĕ` */
		}

		/* t~? */
		if(joy & TRG_B) break;
	}
}

/* ~LVORAMX^bNœ삳邽߂Wrapper */
int driver_mix(DRIVER* driver, short wbuff[], void(*mix)(DRIVER* driver, short wbuff[]));
asm("
	.code
	.align 1
driver_mix:
	pushn %r0
	ld.w %r0, %sp		; X^bNޔ
	xld.w %r10, 0x1000	; 0x0e00`0x1000ɃX^bNؑ
	ld.w %sp, %r10
	call %r14		; {%r12=driver,%r13=wbuff}ێ܂܁Acall %r14=mix
	ld.w %sp, %r0		; X^bN
	popn %r0
	ret
");

int
stream_callback(short wbuff[], int param)
{
	static unsigned char fram4_save[0x200];  /* rs`shbII */
	memcpy(fram4_save, (void*)0xe00, 0x200); /* 0xe00`0xfffޔ */
	driver_mix(&g_driver, wbuff, (void (*)(DRIVER*, short[]))param);
	memcpy((void*)0xe00, fram4_save, 0x200); /* 0xe00`0xfff */
	return 0;
}

//{{gbNTpev[gł
#if 0
	{ "TRACK 00",  0 },
	{ "TRACK 01",  1 },
	{ "TRACK 02",  2 },
	{ "TRACK 03",  3 },
	{ "TRACK 04",  4 },
	{ "TRACK 05",  5 },
	{ "TRACK 06",  6 },
	{ "TRACK 07",  7 },
	{ "TRACK 08",  8 },
	{ "TRACK 09",  9 },
	{ "TRACK 10", 10 },
	{ "TRACK 11", 11 },
	{ "TRACK 12", 12 },
	{ "TRACK 13", 13 },
	{ "TRACK 14", 14 },
	{ "TRACK 15", 15 },
	{ "TRACK 16", 16 },
	{ "TRACK 17", 17 },
	{ "TRACK 18", 18 },
	{ "TRACK 19", 19 },
	{ "TRACK 20", 20 },
	{ "TRACK 21", 21 },
	{ "TRACK 22", 22 },
	{ "TRACK 23", 23 },
	{ "TRACK 24", 24 },
	{ "TRACK 25", 25 },
	{ "TRACK 26", 26 },
	{ "TRACK 27", 27 },
	{ "TRACK 28", 28 },
	{ "TRACK 29", 29 },
	{ "TRACK 30", 30 },
	{ "TRACK 31", 31 },
	{ "TRACK 32", 32 },
	{ "TRACK 33", 33 },
	{ "TRACK 34", 34 },
	{ "TRACK 35", 35 },
	{ "TRACK 36", 36 },
	{ "TRACK 37", 37 },
	{ "TRACK 38", 38 },
	{ "TRACK 39", 39 },
	{ "TRACK 40", 40 },
	{ "TRACK 41", 41 },
	{ "TRACK 42", 42 },
	{ "TRACK 43", 43 },
	{ "TRACK 44", 44 },
	{ "TRACK 45", 45 },
	{ "TRACK 46", 46 },
	{ "TRACK 47", 47 },
	{ "TRACK 48", 48 },
	{ "TRACK 49", 49 },
	{ "TRACK 50", 50 },
	{ "TRACK 51", 51 },
	{ "TRACK 52", 52 },
	{ "TRACK 53", 53 },
	{ "TRACK 54", 54 },
	{ "TRACK 55", 55 },
	{ "TRACK 56", 56 },
	{ "TRACK 57", 57 },
	{ "TRACK 58", 58 },
	{ "TRACK 59", 59 },
	{ "TRACK 60", 60 },
	{ "TRACK 61", 61 },
	{ "TRACK 62", 62 },
	{ "TRACK 63", 63 },
	{ "TRACK 64", 64 },
	{ "TRACK 65", 65 },
	{ "TRACK 66", 66 },
	{ "TRACK 67", 67 },
	{ "TRACK 68", 68 },
	{ "TRACK 69", 69 },
	{ "TRACK 70", 70 },
	{ "TRACK 71", 71 },
	{ "TRACK 72", 72 },
	{ "TRACK 73", 73 },
	{ "TRACK 74", 74 },
	{ "TRACK 75", 75 },
	{ "TRACK 76", 76 },
	{ "TRACK 77", 77 },
	{ "TRACK 78", 78 },
	{ "TRACK 79", 79 },
	{ "TRACK 80", 80 },
	{ "TRACK 81", 81 },
	{ "TRACK 82", 82 },
	{ "TRACK 83", 83 },
	{ "TRACK 84", 84 },
	{ "TRACK 85", 85 },
	{ "TRACK 86", 86 },
	{ "TRACK 87", 87 },
	{ "TRACK 88", 88 },
	{ "TRACK 89", 89 },
	{ "TRACK 80", 80 },
	{ "TRACK 91", 91 },
	{ "TRACK 92", 92 },
	{ "TRACK 93", 93 },
	{ "TRACK 94", 94 },
	{ "TRACK 95", 95 },
	{ "TRACK 96", 96 },
	{ "TRACK 97", 97 },
	{ "TRACK 98", 98 },
	{ "TRACK 99", 99 },
#endif
//}}gbNTpev[gł
